/*! Copyright (c) 2002-2008 SAS Institute, Inc.  All rights reserved. */

/* ------------------------------------------------------------------------ *
 * Purpose: Contains the javascript classes and methods for the             *
 *          ExceptionHighlightingSelector class 		                    *
 *                                                                          *
 * Author:                                                                  *
 * Version:  1.0                                                            *
 *                                                                          *
 * ------------------------------------------------------------------------ */
sas.provides("sas_ExceptionHighlightingChartSelector");
// Author: saszjt 10/23/04
RULE_EDIT_AREA=1;
RULE_SELECT_LEVELS_AREA=2;
currentArea = RULE_EDIT_AREA;
var currentSelectedLevels;

//--------------------------------------------------------------------
// Commit Exception Highlighting Rules
//--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_commit()
{

	if(currentArea==RULE_EDIT_AREA)
	{
		var commit=true;
		var clearRule=false;
		
		if(sas_exceptionHighlightingSelector_rulePresent()==true)
		{
			if(sas_exceptionHighlightingSelector_validateRule()==true)
				commit=true;
			else
				commit=false;
		}
		else
		{
			commit=true;
			clearRule=true;
		}
		
		if(commit==true)
		{

			remoteForm = document.forms[remoteScriptFormName];
//			remoteForm = document.getElementsByName(remoteScriptFormName)[0];	
			if(clearRule==true)
				remoteForm.elements[apPrefix+"remoteAction"].value="CLEAR";
			else
			{
				remoteForm.elements[apPrefix+"remoteAction"].value="ADDRULE";
				sas_exceptionHighlightingSelector_moveValuesToForm();
			}
			remoteForm.submit();

			if(sas_exceptionHighlightingSelector_isWRS()==true)
			{
//				form = document.getElementsByName(formName)[0];				
//				form.submit();
//				window.close();
			}
		}
	}
	else
	if(currentArea==RULE_SELECT_LEVELS_AREA)
	{
		currentSelectedLevels=sas_exceptionHighlightingSelector_getSelectedLevels();
		sas_exceptionHighlightingSelector_hideSelectLevels();
	}
	
}

 //--------------------------------------------------------------------
 // Cancel Exception Highlighting Rules
 //--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_cancel()
{
	if(currentArea==RULE_EDIT_AREA)
	{
		window.close();
	}
	else
	if(currentArea==RULE_SELECT_LEVELS_AREA)
	{
		if(currentSelectedLevels==null)
			currentSelectedLevels=defaultLevels;
		sas_exceptionHighlightingSelector_setSelectedLevels(currentSelectedLevels);

		sas_exceptionHighlightingSelector_hideSelectLevels();
	}
}

function sas_exceptionHighlightingSelector_moveValuesToForm()
{
//	remoteForm = document.getElementsByName(formName)[0];
	remoteForm = document.forms[remoteScriptFormName];
	//remoteForm = document.getElementsByName(remoteScriptFormName)[0];
	var measureSelectedIndex = document.getElementById(measureComboId).selectedIndex;
	if(measureSelectedIndex>-1)
	{
		remoteForm.elements[apPrefix+"remoteMeasure"].value = document.getElementById(measureComboId).options[measureSelectedIndex].value;	
		remoteForm.elements[apPrefix+"remoteMeasureText"].value = document.getElementById(measureComboId).options[measureSelectedIndex].text;			
	}
	
	remoteForm.elements[apPrefix+"remoteIsMeasure"].value = true;
		
	var conditionSelectedIndex = document.getElementById(conditionComboId).selectedIndex;
	if(conditionSelectedIndex>-1)
	{
		remoteForm.elements[apPrefix+"remoteCondition"].value = document.getElementById(conditionComboId).options[conditionSelectedIndex].value;	
		remoteForm.elements[apPrefix+"remoteConditionText"].value = document.getElementById(conditionComboId).options[conditionSelectedIndex].text;					
	}
		

	var valueCombo = eval(valueComboId);
	if(valueCombo.getSelectedIndex()>-1)
	{
		remoteForm.elements[apPrefix+"remoteValue"].value = valueCombo.listBoxComponent.options[valueCombo.getSelectedIndex()].value;
		remoteForm.elements[apPrefix+"remoteValueText"].value = valueCombo.listBoxComponent.options[valueCombo.getSelectedIndex()].text;					
	}
	else
	{
		remoteForm.elements[apPrefix+"remoteValue"].value =	valueCombo.textComponent.value;
		remoteForm.elements[apPrefix+"remoteValueText"].value =	"";					
	}

	var minValueCombo = eval(minValueComboId);
	if(minValueCombo.getSelectedIndex()>-1)
	{
		remoteForm.elements[apPrefix+"remoteMinValue"].value = minValueCombo.listBoxComponent.options[minValueCombo.getSelectedIndex()].value;
		remoteForm.elements[apPrefix+"remoteMinValueText"].value = minValueCombo.listBoxComponent.options[minValueCombo.getSelectedIndex()].text;					
	}
	else
	{
		remoteForm.elements[apPrefix+"remoteMinValue"].value =	minValueCombo.textComponent.value;
		remoteForm.elements[apPrefix+"remoteMinValueText"].value =	"";					
	}

	var maxValueCombo = eval(maxValueComboId);
	if(maxValueCombo.getSelectedIndex()>-1)
	{
		remoteForm.elements[apPrefix+"remoteMaxValue"].value = maxValueCombo.listBoxComponent.options[maxValueCombo.getSelectedIndex()].value;
		remoteForm.elements[apPrefix+"remoteMaxValueText"].value = maxValueCombo.listBoxComponent.options[maxValueCombo.getSelectedIndex()].text;					
	}
	else
	{
		remoteForm.elements[apPrefix+"remoteMaxValue"].value =	maxValueCombo.textComponent.value;
		remoteForm.elements[apPrefix+"remoteMaxValueText"].value =	"";					
	}

	rsForm = document.forms[remoteScriptFormName];
//	rsForm = document.getElementsByName(remoteScriptFormName)[0];
    //remove previously added hidden fields for level selections
    var childNodes = this.rsForm.childNodes;
    if (childNodes != null)
    {
		for (var k=0; k<childNodes.length; k++)
		{
		    var childNode = childNodes.item(k);
		    if (childNode.name == apPrefix + 'remoteSelectedLevels')
		    {
				this.rsForm.removeChild(childNode);
		    }
		}
    }

	remoteForm.elements[apPrefix+"remoteApplyToSelectedIndex"].value = sas_exceptionHighlightingSelector_getApplyToRadioSelectedIndex();
	if(sas_exceptionHighlightingSelector_getApplyToRadioSelectedIndex()=='1')
	{
	    // add hidden fields for each selected level
	    var checked = new Array;
		var allchecked = new Array;
		sas_TreeView_minimalGatherChecked(eval(selectLevelsTreeId).root,checked,allchecked)
	    for (var i=0; i < checked.length; i++)
	    {
	        var hidden = document.createElement("INPUT");
	        hidden.type = "hidden";
	        hidden.name = apPrefix + 'remoteSelectedLevels';
	        hidden.value = checked[i].value;
	        this.rsForm.appendChild(hidden);
	    }
	}	
}


function sas_exceptionHighlightingSelector_getApplyToRadioSelectedIndex()
{
	var selectedIndex;
	if(document.getElementById(applyToRadioId +"0").checked)
		selectedIndex='0';
	if(document.getElementById(applyToRadioId +"1").checked)
		selectedIndex='1';
	return selectedIndex;

}


//--------------------------------------------------------------------
// Show Select Levels Divs
//--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_showSelectLevels()
{
	currentArea = RULE_SELECT_LEVELS_AREA;
	
	document.getElementById('editRule').style.display="none" ;	
	document.getElementById('selectLevels').style.display="" ;
	sas_exceptionHighlightingSelector_resize();
	
}

//--------------------------------------------------------------------
// Hide Select Levels Divs
//--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_hideSelectLevels()
{
	currentArea = RULE_EDIT_AREA;
	document.getElementById('selectLevels').style.display="none" ;
	document.getElementById('editRule').style.display="" ;	
	sas_exceptionHighlightingSelector_resize();
}


//--------------------------------------------------------------------
// Show Select Levels Divs
//--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_showApplyTo()
{
	document.getElementById('applyRuleToRadioRow').style.display="" ;
	document.getElementById('selectLevelsButtonRow').style.display="" ;	

	// resizes the window to fit the components
	sas_exceptionHighlightingSelector_resize();
	
}

//--------------------------------------------------------------------
// Hide Select Levels Divs
//--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_hideApplyTo()
{
	document.getElementById('applyRuleToRadioRow').style.display="none" ;
	document.getElementById('selectLevelsButtonRow').style.display="none" ;	
	
}


function sas_exceptionHighlightingSelector_setSelectLevelsButtonState()
{
	if(sas_exceptionHighlightingSelector_getApplyToRadioSelectedIndex()=='0')
		sas_disable(selectLevelsButtonId);	
//		setState(selectLevelsButtonId,'DISABLED');							
	else
		sas_enable(selectLevelsButtonId);	
//		setState(selectLevelsButtonId,null);								
}

 //--------------------------------------------------------------------
 // Clear add/edit rule info
 //--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_clearRule()
{
	
	document.getElementById(measureComboId).selectedIndex=0;
	document.getElementById(conditionComboId).selectedIndex=0;	


	eval(valueComboId).setSelectedIndex(0);
//	eval(valueComboId).setAttribute("value","");


	eval(minValueComboId).setSelectedIndex(0);
//	eval(minValueComboId).setAttribute("value","");

	eval(maxValueComboId).setSelectedIndex(0);
//	eval(maxValueComboId).setAttribute("value","");

		
	document.getElementById(applyToRadioId+'0').checked=true;

	sas_exceptionHighlightingSelector_setSelectedLevels(defaultLevels);

	sas_disable(selectLevelsButtonId);	 
//	setState(selectLevelsButtonId,'DISABLED');		

	sas_exceptionHighlightingSelector_checkMissingValueCondition();
	sas_exceptionHighlightingSelector_checkBetweenCondition();
	
}

 //--------------------------------------------------------------------
 // Populate add/edit rule info
 //--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_populateRule(ruleProps, selectedLevels)
{
	
	document.getElementById(measureComboId).value=ruleProps.measure;	
	document.getElementById(conditionComboId).value=ruleProps.condition;	

	if(ruleProps.value=='')
		eval(valueComboId).setSelectedIndex(0);
	else
	{
		eval(valueComboId).setSelectedItem(ruleProps.value);
		if(eval(valueComboId).getSelectedIndex()==-1)
			eval(valueComboId).setAttribute("value",ruleProps.value);
	}
	
	if(ruleProps.minValue=='')
		eval(minValueComboId).setSelectedIndex(0);
	else
	{
		eval(minValueComboId).setSelectedItem(ruleProps.minValue);
		if(eval(minValueComboId).getSelectedIndex()==-1)
			eval(minValueComboId).setAttribute("value",ruleProps.minValue);
	}

	if(ruleProps.maxValue=='')
		eval(maxValueComboId).setSelectedIndex(0);
	else
	{
		eval(maxValueComboId).setSelectedItem(ruleProps.maxValue);
		if(eval(maxValueComboId).getSelectedIndex()==-1)
			eval(maxValueComboId).setAttribute("value",ruleProps.maxValue);
	}

	document.getElementById(applyToRadioId+ruleProps.applyToSelectedIndex).checked=true;
	sas_exceptionHighlightingSelector_setSelectLevelsButtonState();	
	
	sas_exceptionHighlightingSelector_setSelectedLevels(selectedLevels);	

	sas_exceptionHighlightingSelector_checkMissingValueCondition();
	sas_exceptionHighlightingSelector_checkBetweenCondition();

}

//Added for defect S0477206
function sas_exceptionHighlightingSelector_getSelectedLevels()
{
	var levels = new Array();
	if(sas_exceptionHighlightingSelector_getApplyToRadioSelectedIndex()=='1')
	{
	    // add hidden fields for each selected level
	    var checked = new Array;
		var allchecked = new Array;
		sas_TreeView_minimalGatherChecked(eval(selectLevelsTreeId).root,checked,allchecked)
	    for (var i=0; i < checked.length; i++)
	    {
		  levels[i]=checked[i].value;
		}
	}	
	return levels;
}


function sas_exceptionHighlightingSelector_setSelectedLevels(levels)
{
	eval(selectLevelsTreeId).selections.clear();
	sas_TreeView_cbSetAllChildren(eval(selectLevelsTreeId).root, false);	
	for(var i=0; i<levels.length;i++)
	{
		var node=eval(selectLevelsTreeId).getNode(levels[i]);
		if(node!=null)
		{
	 		sas_TreeView_cbCheck(node, true);
			eval(selectLevelsTreeId).selections.appendNode(node);
		}
	}
}

function sas_exceptionHighlightingSelector_checkMissingValueCondition()
{
	if(sas_exceptionHighlightingSelector_isCondition(missingValueCondition)==true)
	{
		eval(valueComboId).setSelectedIndex(-1);
		eval(valueComboId).setAttribute("value","");
		eval(valueComboId).setEnabled(false);		
		
		return true;			
	}
	else
	{
		eval(valueComboId).setEnabled(true);			
		return false;
	}
}

function sas_exceptionHighlightingSelector_checkBetweenCondition()
{
	if(sas_exceptionHighlightingSelector_isCondition(betweenCondition)==true)
	{
		document.getElementById('minValueRow').style.display="" ;
		document.getElementById('maxValueRow').style.display="" ;		
		document.getElementById('valueRow').style.display="none" ;		
		sas_exceptionHighlightingSelector_resize();		

		eval(minValueComboId).positionIFrameCombo();
		eval(maxValueComboId).positionIFrameCombo();		
		
		return true;			
	}
	else
	{
		document.getElementById('minValueRow').style.display="none" ;
		document.getElementById('maxValueRow').style.display="none" ;		
		document.getElementById('valueRow').style.display="" ;		

		sas_exceptionHighlightingSelector_resize();				
		eval(valueComboId).positionIFrameCombo();		
		return false;
	}

}

function sas_exceptionHighlightingSelector_isCondition(condition)
{
	var conditionSelectedIndex = document.getElementById(conditionComboId).selectedIndex;
	if(conditionSelectedIndex>-1)
	{
		selectedConditionValue = document.getElementById(conditionComboId).options[conditionSelectedIndex].value;	
		if(selectedConditionValue==condition)
		{
			return true;			
		}
		else
		{
			return false;
		}
	}
	
	return false;
}

function sas_exceptionHighlightingSelector_rulePresent()
{
	var present=false;
	
	if(document.getElementById(measureComboId).selectedIndex>0)
	{
		present=true;
	}

	if(document.getElementById(conditionComboId).selectedIndex>0)
	{
		present=true;
	}
		
    if((eval(valueComboId).getSelectedIndex()!=-1 || eval(valueComboId).textComponent.value!="") && eval(valueComboId).getSelectedIndex()!=0)
    {
    	present=true; 
	}

    if((eval(minValueComboId).getSelectedIndex()!=-1 || eval(minValueComboId).textComponent.value!="") && eval(minValueComboId).getSelectedIndex()!=0)	
    {
    	present=true; 
	}

    if((eval(maxValueComboId).getSelectedIndex()!=-1 || eval(maxValueComboId).textComponent.value!="") && eval(maxValueComboId).getSelectedIndex()!=0)	
    {
    	present=true; 
	}

    	
    return present;
}

function sas_exceptionHighlightingSelector_validateRule()
{
	var valid=true;
	var message='';
	var measureSelectedIndex = document.getElementById(measureComboId).selectedIndex;
	var conditionSelectedIndex = document.getElementById(conditionComboId).selectedIndex;
	var valueCombo = eval(valueComboId);
	
	
	if(measureSelectedIndex<1)
	{
		valid=false;
		message = message + msgMeasureRequired + '\n';
	}

	if(conditionSelectedIndex<1)
	{
		valid=false;
		message = message + msgConditionRequired + '\n';		
	}
	 
		
		if(sas_exceptionHighlightingSelector_checkBetweenCondition()==true)
		{
		    if((eval(minValueComboId).getSelectedIndex()>-1 || sas_exceptionHighlightingSelector_isEmpty(eval(minValueComboId).textComponent.value)!=true) &&
		    (eval(maxValueComboId).getSelectedIndex()>-1 || sas_exceptionHighlightingSelector_isEmpty(eval(maxValueComboId).textComponent.value)!=true)  &&
		     eval(minValueComboId).getSelectedIndex()!=0 && eval(maxValueComboId).getSelectedIndex()!=0)
			{
				if(eval(minValueComboId).getSelectedIndex()==-1)
				{
						//validate the value
						if(eval(maxValueComboId).getSelectedIndex()==-1) //validate both min and max values
							parms = {value1 : eval(minValueComboId).textComponent.value, value2 : eval(maxValueComboId).textComponent.value, METHOD : "validateValue" };
						else  //just the min value needs validating
							parms = {value1 : eval(minValueComboId).textComponent.value, METHOD : "validateValue" };
						sas.ajax.send(ajaxUrl, parms, function(type, data, xhr, options){eval(xhr.responseText);
								if(return_Obj.value1Error){ 
									valid = false; 
									message = message + msgMinValueNumeric + '\n';
								}	
								if(return_Obj.value2Error){ 
									valid = false; 
									message = message + msgMaxValueNumeric + '\n';
								}	
								if(return_Obj.minMaxError){ 
									valid = false; 
									message = message + msgMinMaxFlipped + '\n';
								}}, null, true);
				}
				else if(eval(maxValueComboId).getSelectedIndex()==-1 )
				{ //Validate the max value
					parms = {value2 : eval(maxValueComboId).textComponent.value, METHOD : "validateValue" };
						sas.ajax.send(ajaxUrl, parms, function(type, data, xhr, options){eval(xhr.responseText);
																	if(return_Obj.value2Error){ 
																		valid = false; 
																		message = message + msgMaxValueNumeric + '\n';
																	}}, null, true);
				}
			

			}
			else
			{
				message = message + msgMinMaxValueRequired + '\n';
				valid = false;
			}
			
		}
		else
		{
			if(sas_exceptionHighlightingSelector_checkMissingValueCondition()==false)		
			{
			    if((valueCombo.getSelectedIndex()==-1 && sas_exceptionHighlightingSelector_isEmpty(valueCombo.textComponent.value)==true) ||
			    (valueCombo.getSelectedIndex()==0))
				{
					valid=false;
					message = message + msgValueRequired + '\n';
				}
				else
				{
					//S0474379 verify value with ajax call
					if(eval(valueComboId).getSelectedIndex()==-1)
					{
						//validate the value
						parms = {
									value1 : eval(valueComboId).textComponent.value,
									METHOD : "validateValue" 
								};
						sas.ajax.send(ajaxUrl, parms, function(type, data, xhr, options){eval(xhr.responseText);
																	if(return_Obj.value1Error){ valid = false; message = message + msgValueNumeric + '\n';}	
																	}, null, true);
					}

				}
			}
		}
		
	if(valid==false)
		alert(message);
	return valid;
}

    function setState(name, value)
    {
        element = document.getElementById(name);
        element.disabled = value;
    }

function sas_exceptionHighlightingSelector_isWRS()
{
    var container = document.getElementById("outerSelectorContainer");
    if(container!=null)
    	return false;
    else
    	return true;
}
function sas_exceptionHighlightingSelector_resize()
{
	if(sas_exceptionHighlightingSelector_isWRS()==false )
	{
		//S0473783 fix to allow non-IE browsers resize
		if((xIE && document.readyState=='complete') || !xIE)
		{
		    var container = document.getElementById("outerSelectorContainer");	
		    sas_sizeWindowToContent(container);
		}
	}
}

function setFocus(name)
{
       element = document.getElementById(name);
       element.focus();
}

 //--------------------------------------------------------------------
 // Initialize IFrame Combos
 //--------------------------------------------------------------------
function sas_exceptionHighlightingSelector_initCombos()
{
	var tmpValueCombo = eval(valueComboId);
	var valueTable = document.getElementById(tmpValueCombo.id +"_Table");
	valueTable.style.width = "100%";
	tmpValueCombo.textComponent.style.width="100%";
	var tmpMinCombo = eval(minValueComboId);
	var minTable = document.getElementById(tmpMinCombo.id +"_Table");
	minTable.style.width = "100%";
	tmpMinCombo.textComponent.style.width="100%";
	var tmpMaxCombo = eval(maxValueComboId);
	var maxTable = document.getElementById(tmpMaxCombo.id +"_Table");
	maxTable.style.width = "100%";
	tmpMaxCombo.textComponent.style.width="100%";
	eval(valueComboId).positionIFrameCombo();
	eval(minValueComboId).positionIFrameCombo();
	eval(maxValueComboId).positionIFrameCombo();		
	sas_exceptionHighlightingSelector_resize();
	
}

function sas_exceptionHighlightingSelector_trimLeadingAndTrailingSpaces(value)
{
	return(value.replace(/^\s+|\s+$/g, ''));
}

function sas_exceptionHighlightingSelector_isEmpty(value)
{
	if(sas_exceptionHighlightingSelector_trimLeadingAndTrailingSpaces(value)=="")
		return true;
	else
		return false;
}



