<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<% try { // START: DEBUG %>
<%@ page errorPage="/errorPage.jsp" %>

<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>

<%@ page import="com.sas.apps.citation.model.user.SessionScopeManager" %>
<%@ page import="com.sas.apps.citation.view.beans.PagePropertyBean" %>
<%@ page import="com.sas.apps.citation.view.beans.reportmanagement.OpenReportManager" %> 
<%@ page import="com.sas.apps.citation.view.util.PageErrorProcessor" %>
<%@ page import="com.sas.apps.citation.view.util.ViewUtils" %>
<%@ page import="com.sas.apps.citation.controller.action.report.ReportControllerAction" %>
<%@ page import="com.sas.apps.citation.view.beans.SectionPaneFormBean" %>
<%@ page import="com.sas.apps.citation.view.beans.reportmanagement.OpenReport" %>
<%
    SessionScopeManager smgr    = SessionScopeManager.getSessionScopeManager(request);
    OpenReport openReport       = OpenReportManager.getCurrentOpenReport(smgr);
  
    //no need to pollute session with objects only necessary for an isolated request
    SectionPaneFormBean sectionPaneForm = new SectionPaneFormBean();
    sectionPaneForm.initialize(smgr, openReport);

    boolean isViewMode = sectionPaneForm.isViewActive();
    boolean isEditMode = sectionPaneForm.isEditActive();
    boolean isPrompted = ViewUtils.isPromptPageRequest(request);
    int sectionCount = sectionPaneForm.getSectionCount();
    String disabledStatus = (sectionCount == 1) ? "disabled=\"disabled\"" : "";
    
    int currentSectionIndex = sectionPaneForm.getCurrentSectionIndex();
    
    String tooltipText = PagePropertyBean.getMessage(pageContext,"banner.section.navigator.tooltip.fmt.txt", new String[]{Integer.toString(currentSectionIndex + 1), Integer.toString(sectionCount)});
    
    if (isViewMode || isEditMode || isPrompted) {
%>
       
      <table border="0" cellpadding="3" cellspacing="0" style="text-align:right;" summary="">
        <tr>
            <td>
               <input type="text" <%=disabledStatus%> id="wrsBannerSectionNavigation" 
                     value="<%=currentSectionIndex + 1%>" title="<%=tooltipText %>" 
                     onchange="bannerRibbonEnteredSectionSwitch(this);return false;" 
                     onkeypress="return submitenter(this);"/>
                   <script type="text/javascript"> /*<![CDATA[*/
                     var regExpInvalidSectionNumberChars = /[^\d\r\t]+/;
                     var sectionNumberInput = document.getElementById("wrsBannerSectionNavigation");
                 var invalidCharacterListener = new ProhibitedCharacterListener(sectionNumberInput, regExpInvalidSectionNumberChars);
                  /*]]>*/ </script>
            </td>
            <td>
               <span class="label" title="<%=tooltipText %>">&#47;<%=sectionCount%></span>     
            </td>     
            <td class="dialogSpacer">&nbsp;</td>
           </tr>
         </table>        
   <script type="text/javascript"> /*<![CDATA[*/
   function submitenter(e) 
   {
      var KeyID = (window.event) ? event.keyCode : e.keyCode;
      if (KeyID == 13) {
         bannerRibbonEnteredSectionSwitch(event);
         return false;
      } else  {
         return true;
      }  
   }
   function bannerRibbonEnteredSectionSwitch(event)
   {
      var sectionElem = findDOM('wrsBannerSectionNavigation');
      if (sectionElem) {
         var index = sectionElem.value - 1;
         if (index >= <%=sectionCount%>) index = <%=sectionCount%> - 1; 
         if (index < 0) index = 0;
         bannerRibbonSectionSwitch(event, index);
      }
   }
   /*]]>*/ </script>        
<%
        if (isViewMode || isPrompted) {
%>    
        <script type="text/javascript"> /*<![CDATA[*/
        var g_bannerRibbonSectionSwitchLinks = new Array(<%=sectionCount%>);
        <% for (int iSec = 0; iSec < sectionCount; iSec++) { %>
              g_bannerRibbonSectionSwitchLinks[<%=iSec%>] = '<%=ReportControllerAction.createGotoViewerSectionLink(iSec)%>';
        <% }  %>  
        function bannerRibbonSectionSwitch(event, sectionIndex) {
            showDebugMsgs("section Switch to", sectionIndex);
            if(gotoReportSection) // S0915162
            {
               gotoReportSection(""+sectionIndex); // S0915162
            }
            else
            {
                window.location =  g_bannerRibbonSectionSwitchLinks[sectionIndex];   
            }
        }
        /*]]>*/ </script>
<%
        } else {  // NOT view mode
%>         
        <script type="text/javascript"> /*<![CDATA[*/
        function bannerRibbonSectionSwitch(event, sectionIndex) {
            rsSubmit('/sendEditorState.do',  'WrsEdit.changeSection',  sectionIndex);
        }
        /*]]>*/ </script>

<%
        }  
    }       
} 
catch (Exception ex) 
{
    PageErrorProcessor.setJspError(ex, pageContext, out);
} 
// END: DEBUG %>


